// ---------------------------------------------------------------------------
//       .
//
//       20 ,     
//   10    .
//
//        "  ".
//
//    forum.mql4.com.
// ---------------------------------------------------------------------------

#property copyright "Azzx, 2010-2012"
#property link      "mailto:agapito@rambler.ru"

#include <stderror.mqh>
#include <stdlib.mqh>

//   .
#define DON_NAME   "azzx_donchian_1_0"
#define DON_UPPER  0
#define DON_LOWER  1
#define DON_MIDDLE 2

//   .
#define MAGIC    100
//  .
#define SLIPPAGE 30

// ---------------------------------------------------------------------------
//   .
// ---------------------------------------------------------------------------

extern string   _1            = 
  "<br><b>---      ---</b><br>";
extern int      ENTER_CHANNEL = 20;
extern string   _2            = 
  "<br><b>---      ---</b><br>";
extern int      EXIT_CHANNEL  = 10;
extern string   _3            = 
  "<br><b>---   () ---</b><br>";
extern datetime BEGIN_DATE    = D'2006.01.01';
extern string   _4            = 
  "<br><b>---   ( ) ---</b><br>";
extern datetime END_DATE      = D'2011.01.01';

// ---------------------------------------------------------------------------
//   .
// ---------------------------------------------------------------------------

//  .
int      error_count = 0;
//   .
datetime last_bar    = 0;
//   .
bool     active      = false;
//  .
double   channel_top, channel_bottom;

// ---------------------------------------------------------------------------
//   .
// ---------------------------------------------------------------------------

int start() {
  //      
  //    .
  if(last_bar != Time[0]) {
    last_bar = Time[0];
  
    //  .
    channel_top    = iCustom(NULL, 0, DON_NAME, ENTER_CHANNEL, DON_UPPER, 1);
    channel_bottom = iCustom(NULL, 0, DON_NAME, ENTER_CHANNEL, DON_LOWER, 1);
  }

  //  .
  move_order();

  //  .
  if(is_allowed_date() == true) {
    set_activity_mode();
    watch_breakout();
  } else {
    active = false;
  }
  
  //   .
  Comment("errors: ", error_count);
  
  return(0);
}

// ---------------------------------------------------------------------------
//   .
// ---------------------------------------------------------------------------

//    .
//  -1,   .
int get_ticket() {
  int i;
  
  for(i = OrdersTotal() - 1; i >= 0; i--) {
    OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
    
    if(OrderMagicNumber() == MAGIC) {
      return(OrderTicket());
    }
  }
  
  return(-1);
}

//     .
double long_stoploss() {
  return(NormalizeDouble(
    iCustom(NULL, 0, DON_NAME, EXIT_CHANNEL, DON_LOWER, 1), Digits));
}

//     .
double short_stoploss() {
  return(NormalizeDouble((Ask - Bid) +
    iCustom(NULL, 0, DON_NAME, EXIT_CHANNEL, DON_UPPER, 1), Digits));
}

//  .
void move_order() {
  int    error, ticket = get_ticket();
  double stoploss;
  
  if(ticket != -1) {
    OrderSelect(ticket, SELECT_BY_TICKET, MODE_TRADES);
    
    if(OrderType() == OP_BUY) {
      stoploss = long_stoploss();
    } else {
      stoploss = short_stoploss();
    }

    if(stoploss != NormalizeDouble(OrderStopLoss(), Digits)) {
      if(OrderModify(ticket, 0, stoploss, 0, 0) == false) {
        error = GetLastError();
        
        if(error != ERR_INVALID_STOPS) {
          register_error(error, "  ");
          error_count++;
        }
      }
    }
  } 
}

//  .
void watch_breakout() {
  if(active != true) return;
  
  int ticket = 0;
  
  if(Bid >= channel_top) {
    ticket   = OrderSend(Symbol(), OP_BUY, 1, 
      Ask, SLIPPAGE, long_stoploss(), 0, "LONG", MAGIC); 
  }
   
  if(Bid <= channel_bottom) {
    ticket   = OrderSend(Symbol(), OP_SELL, 1,
      Bid, SLIPPAGE, short_stoploss(), 0, "SHORT", MAGIC);
  }

  if(ticket == -1) {
    register_error(GetLastError(), "  ");
    error_count++;
  }
}

//     .
void set_activity_mode() {
  active = false;

  //    ,     
  //    .   
  //  ,       
  //   .
  if(get_ticket() == -1) {
    active = (Close[1] < channel_top) && (Close[1] > channel_bottom);
  }
}

//      .
bool is_allowed_date() {
  return((last_bar >= BEGIN_DATE) && (last_bar < END_DATE));
}

//   -      
//   .
void register_error(int code, string text) {
  Print("*** ERROR: ", code, ", ", text);
}


